//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit2.h"
//---------------------------------------------------------------------
#pragma resource "*.dfm"
TUsedVarsEditDlg *UsedVarsEditDlg;
//---------------------------------------------------------------------
__fastcall TUsedVarsEditDlg::TUsedVarsEditDlg(TComponent* AOwner)
	: TForm(AOwner)
{
}
//---------------------------------------------------------------------
void __fastcall TUsedVarsEditDlg::FormShow(TObject *Sender)
{
   if (AnExParser!=NULL) ListBox1->Items->Assign(AnExParser->UsedVariables);
}
//---------------------------------------------------------------------------

void __fastcall TUsedVarsEditDlg::Edit1KeyPress(TObject *Sender, char &Key)
{
  if ((Key != VK_BACK) && (Key != VK_DELETE) && !((Key>='0') && (Key<='9'))
      && (Key != DecimalSeparator) && (Key != '+') && (Key != '-')) Key = 0x0;
}
//---------------------------------------------------------------------------

void __fastcall TUsedVarsEditDlg::ListBox1DrawItem(TWinControl *Control,
      int Index, TRect &Rect, TOwnerDrawState State)
{
  Extended VV;
  char *PCh;
  int RR;
  PCh =new char[127];
  if (ListBox1->Items->Objects[Index] != NULL)
    VV=((TVariable *)(ListBox1->Items->Objects[Index]))->Value;
  else VV=0;
  ListBox1->Canvas->FillRect(Rect); RR=Rect.Right;
  Rect.Left+=2; Rect.Right=Rect.Left+Header1->SectionWidth[0]-2;
  StrPCopy(PCh,ListBox1->Items->Strings[Index]);
  DrawText(ListBox1->Canvas->Handle,PCh,StrLen(PCh),(tagRECT *)&Rect,DT_LEFT | DT_VCENTER);
  Rect.Left+=Header1->SectionWidth[0]; Rect.Right=RR-2;
  StrPCopy(PCh,FloatToStr(VV));
  DrawText(ListBox1->Canvas->Handle,PCh,StrLen(PCh),(tagRECT *)&Rect,DT_RIGHT | DT_VCENTER);
  delete[] PCh;
}
//---------------------------------------------------------------------------

void __fastcall TUsedVarsEditDlg::Header1Sizing(TObject *Sender,
      int ASection, int AWidth)
{
   ListBox1->Repaint(); 
}
//---------------------------------------------------------------------------

void __fastcall TUsedVarsEditDlg::ListBox1Click(TObject *Sender)
{
  int AnIdx;
  AnIdx=ListBox1->ItemIndex;
  if ((AnIdx>=0) && (AnIdx<ListBox1->Items->Count))
    Edit1->Text=FloatToStr(AnExParser->UsedVariables->Value[AnIdx]);
}
//---------------------------------------------------------------------------

void __fastcall TUsedVarsEditDlg::Button1Click(TObject *Sender)
{
  int AnIdx;
  AnIdx=ListBox1->ItemIndex;
  if ((AnIdx>=0) && (AnIdx<ListBox1->Items->Count))
  {
     try 
     {
       AnExParser->UsedVariables->Value[AnIdx]=StrToFloat(Edit1->Text);
     }
     catch(...){
      AnExParser->UsedVariables->Value[AnIdx]=0;
     }
     ListBox1->Repaint();
  }
}
//---------------------------------------------------------------------------

